{6- En un depsito de mercaderas se utiliza un archivo (MERC.DAT) para almacenar informacin referida a cada producto. Al final del da se debe actualizar ese archivo para dejar constancia de las operaciones realizadas en cada jornada. Esta informacin se halla en un archivo llamado NOVE.DAT.}
{Cada registro del archivo MERC.DAT contiene los campos siguientes:}
{Cdigo de producto.}
{Descripcin.}
{Unidades en existencia.}
{Para los registros del archivo NOVE.DAT los campos son:}
{Cdigo de producto.}
{Cantidad vendida o comprada (negativo significa venta, y positivo, compra).}
{Este programa actualiza el archivo MERC.DAT a partir del archivo NOVE.DAT, y devuelve el resultado en el archivo NUEVO.DAT. Todos los archivos estn ordenados de manera ascendente por cdigo de producto.}
{Aclaracin: no se proveen los archivos MERC.DAT y NOVE.DAT (debido a que son binarios). Debern ser generados antes de la ejecucin de este programa.}

{Solucin en lenguaje Pascal}

PROGRAM cap07_ej06;
TYPE 	t_producto = RECORD
	codigo: INTEGER;
	descripcion: STRING[30];
	existencia: INTEGER;
	END;

	t_novedad = RECORD
	codigo: INTEGER;
	cant_transaccion: INTEGER;
	END;

	t_arch_productos = FILE OF t_producto;
	t_arch_novedades = FILE OF t_novedad;
PROCEDURE apareo(VAR fmerc: t_arch_productos; VAR fnov: t_arch_novedades; VAR fnuevo: t_arch_productos);

VAR producto: t_producto;
	novedad: t_novedad;
BEGIN

	RESET(fmerc);
	WHILE (NOT EOF(fmerc)) DO
	BEGIN
		READ(fmerc, producto);
		RESET(fnov);

		WHILE (NOT EOF(fnov)) DO
		BEGIN
			READ(fnov, novedad);
		
			IF (producto.codigo = novedad.codigo) THEN
			BEGIN
				{ Actualizar }
				producto.existencia := producto.existencia + novedad.cant_transaccion;
			END;
		END;

	{$I-}
	WRITE(fnuevo, producto);
	{$I+}
	IF (IORESULT <> 0) THEN
	BEGIN
		WRITELN('Error de escritura de los datos!');
		EXIT;
	END;
	END;
END;

VAR 	fmerc, fnuevo: t_arch_productos;
	fnov: t_arch_novedades;

{ Programa Principal }
BEGIN
	ASSIGN(fmerc,'merc.dat');
	ASSIGN(fnov,'nove.dat');
	ASSIGN(fnuevo,'nuevo.dat');

	{$I-}
	RESET(fmerc);
	{$I+}
	IF (IORESULT <> 0) THEN
	BEGIN
		WRITELN('No se puede abrir el archivo fuente.');
		EXIT;
	END;

	{$I-}
	RESET(fnov);
	{$I+}
	IF (IORESULT <> 0) THEN
	BEGIN
		WRITELN('No se puede abrir el archivo de novedades.');
		CLOSE(fmerc);
	EXIT;
	END;

	{$I-}
	RESET(fnuevo);
	{$I+}
	IF (IORESULT <> 0) THEN
	BEGIN
		WRITELN('No se puede abrir el archivo destino.');
		CLOSE(fmerc);
		CLOSE(fnov);
	EXIT;
	END;

	apareo(fmerc, fnov, fnuevo);

	CLOSE(fmerc);
	CLOSE(fnov);
	CLOSE(fnuevo);
END.